application:setBackgroundColor(0x323232) --set app background
require "ImGui" --require the plugin


local ui = ImGui.new() --create local instance of imgui 
local IO = ui:getIO() --this is mandatory, I guess it's Input/Output interface

--set custom fonts:
local FontAtlas = IO:getFonts() --get fontAtlas
--define custon fonts in fonts table { font[1], font[2], font[3] }
local fonts = FontAtlas:addFonts{ {"fonts/CharisSIL-Regular.ttf", 18}, {"fonts/CharisSIL-Bold.ttf", 28},  {"fonts/CharisSIL-Italic.ttf", 28} }
 
 
--set first font as default font
IO:setFontDefault(fonts[1])
--build updated fontAtlas
FontAtlas:build()
	

function onWindowResize(rt)
	local minX, minY, maxX, maxY = application:getLogicalBounds()
	
	local sx = application:getLogicalScaleX()
	local sy = application:getLogicalScaleY()
 
	ui:setScale(1 / sx, 1 / sy)
	-- move UI to top left corner
	ui:setPosition(minX, minY)
	-- resize display area
	IO:setDisplaySize((maxX - minX) * sx, (maxY - minY) * sy)
	
	
	if rt then --if rt was not empty return the values
		rt = {
			x  = minX,
			X  = maxX,
			y  = minY,
			Y  = maxY,
			Sx = sx,
			Sy = sy,
			w  = (maxX - minX) * sx,
			h  = (maxY - minY) * sy
		}
		return rt
	end
end
--ss stores the values we need in order to center/position stuff on screen: (true) neans that the function must return those values (see above)
local ss = onWindowResize(true)



--this runs every frame to redraw the gui
local function onDrawGui(e)
	ui:newFrame(e.deltaTime)
	
	ui:showDemoWindow()
	
	ui:updateCursor()
	ui:render()
	ui:endFrame()
end


onWindowResize()


stage:addEventListener("enterFrame", onDrawGui) --check onDrawGui every frame
stage:addEventListener("applicationResize", onWindowResize) --check if container app resizes
stage:addChild(ui) --add the gui to stage
